//---------------------------------------------------------------------------
// Copyright (c) Allan Petersen, 1999.
/*
 * Version 1.0.0 of a sample using TOpenGLAPPanel

 * (c) Copyright 1999, Allan Petersen
 * ALL RIGHTS RESERVED
 * Permission to use, copy, modify, and distribute this software for
 * any purpose and without fee is hereby granted, provided that the above
 * copyright notice appear in all copies and that both the copyright notice
 * and this permission notice appear in supporting documentation, and that
 * the name of Allan Petersen not be used in advertising
 * or publicity pertaining to distribution of the software without specific,
 * written prior permission.
 *
 * THE MATERIAL EMBODIED ON THIS SOFTWARE IS PROVIDED TO YOU "AS-IS"
 * AND WITHOUT WARRANTY OF ANY KIND, EXPRESS, IMPLIED OR OTHERWISE,
 * INCLUDING WITHOUT LIMITATION, ANY WARRANTY OF MERCHANTABILITY OR
 * FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT SHALL ALLAN
 * PETERSEN BE LIABLE TO YOU OR ANYONE ELSE FOR ANY DIRECT,
 * SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY
 * KIND, OR ANY DAMAGES WHATSOEVER, INCLUDING WITHOUT LIMITATION,
 * LOSS OF PROFIT, LOSS OF USE, SAVINGS OR REVENUE, OR THE CLAIMS OF
 * THIRD PARTIES, WHETHER OR NOT ALLAN PETERSEN HAS BEEN
 * ADVISED OF THE POSSIBILITY OF SUCH LOSS, HOWEVER CAUSED AND ON
 * ANY THEORY OF LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE
 * POSSESSION, USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * Contact Allan Petersen at <allan.petersen@danbbs.dk> or visit
 * www.danbbs.dk/~allmette
 *
 */
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>
#include "glut.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "TOpenGLAPPanel"
#pragma resource "*.dfm"
Tfrm_pick *frm_pick;

typedef struct {
        float	x,y,z;
        } Point3;

RECT bRect;			// Bounding rectangle
GLuint nWho = 0;		// Who is selected
float fAspect;


enum {
    MB_DOWN,
    MB_UP
    } Emouse;

    GLfloat light0_ambient[] = { 1., 1., 1., 0.0 };
    GLfloat light0_position[] = { 0.6, 0.4, 0.3, 0.0 };
    GLfloat mat_specular[] = { 1.0, 1.0, 1.0, 1.0 };
    GLfloat mat_ambuse[] = { 0.6, 0.0, 0.0, 1.0 };
    GLfloat mat_ambuse2[] = { 1.0, 0.3, 0.0, 1.0 };
    GLfloat mat_shininess = 25.;

    TMouseButton MouseButton;
    float        RotX = 0.0F,
                 RotY = 0.0F;
    GLdouble     ZoomFactor   = -4.0;
    long         MouseStatus = -1;
    long         MPosX, MPosY = 0;
    BMPTexture  *BMPTex = NULL;
    GLint        count;
//    long         DISPLAY = 0;
#define CUBE	1
#define SPHERE	2
    GLdouble    fovy  = 45.0F;
    GLdouble    zNear = 0.1F;
    GLdouble    zFar  = 1200.0F;
    bool        first_run = true;
    clock_t     start;

    long    PlasmaTable[256];       // ----

static int directionalLight = 0;
static float lightAngle = 0.0, lightHeight = 20;

	GLfloat nRange;
    GLsizei w;
    GLsizei h;

GLuint filter;						// Which Filter To Use
GLuint fogMode[]= { GL_EXP, GL_EXP2, GL_LINEAR };	// Storage For Three Types Of Fog
GLuint fogfilter= 0;					// Which Fog To Use
GLfloat fogColor[4]= {0.5f, 0.5f, 0.5f, 1.0f};		// Fog Color


GLint ell,axes;
int theta,beta;
GLfloat dist;


BOOL hitTest(void);

#define N 3
#define AXES 420

typedef struct _Vertex {
	GLfloat v[3];
} Vertex;

int selected = -1;
    long   Start, End;

long    SELNAME = 0;

Vertex vertices[N];
static bool active = false;
  long  num_points = 40;

#define MMOUSE_ENABLED 1
  Point3 *control;

LARGE_INTEGER   TimeBeg,
                TimeEnd,
                TimeFreq;

void evaluateBezierSegment_fd(Point3 *control,int num_points,  Point3 *result);

//---------------------------------------------------------------------------
__fastcall Tfrm_pick::Tfrm_pick(TComponent* Owner)
    : TForm(Owner)
{
    RotateWorld = false;
    start = clock ();
    LightSource = 0;
	control = new Point3[4];
    control[0].x = 10.;
    control[0].y = 0.;
    control[0].z = 0.;

    control[1].x = 0.;
    control[1].y = 0.;
    control[1].z = 0.;

    control[2].x = 10.;
    control[2].y = 10.;
    control[2].z = 10.;

    control[3].x = 10.;
    control[3].y = 0.;
    control[3].z = 10.;
}
GLfloat ctlpoints[4][4][3];

GLUnurbsObj *theNurb;



typedef enum {
  RESERVED, DISPLAY, BODY_SIDE, BODY_EDGE, BODY_WHOLE, ARM_SIDE, ARM_EDGE, ARM_WHOLE,
  LEG_SIDE, LEG_EDGE, LEG_WHOLE, EYE_SIDE, EYE_EDGE, EYE_WHOLE, DINOSAUR
} displayLists;

/* *INDENT-OFF* */
static GLfloat body[][2] = { {0, 3}, {1, 1}, {5, 1}, {8, 4}, {10, 4}, {11, 5},
  {11, 11.5}, {13, 12}, {13, 13}, {10, 13.5}, {13, 14}, {13, 15}, {11, 16},
  {8, 16}, {7, 15}, {7, 13}, {8, 12}, {7, 11}, {6, 6}, {4, 3}, {3, 2},
  {1, 2} };
static GLfloat arm[][2] = { {8, 10}, {9, 9}, {10, 9}, {13, 8}, {14, 9}, {16, 9},
  {15, 9.5}, {16, 10}, {15, 10}, {15.5, 11}, {14.5, 10}, {14, 11}, {14, 10},
  {13, 9}, {11, 11}, {9, 11} };
static GLfloat leg[][2] = { {8, 6}, {8, 4}, {9, 3}, {9, 2}, {8, 1}, {8, 0.5}, {9, 0},
  {12, 0}, {10, 1}, {10, 2}, {12, 4}, {11, 6}, {10, 7}, {9, 7} };
static GLfloat eye[][2] = { {8.75, 15}, {9, 14.7}, {9.6, 14.7}, {10.1, 15},
  {9.6, 15.25}, {9, 15.25} };
static GLfloat skinColor[] = {0.1, 1.0, 0.1, 1.0}, eyeColor[] = {1.0, 0.2, 0.2, 1.0};
/* *INDENT-ON* */

static void
extrudeSolidFromPolygon(GLfloat data[][2], unsigned int dataSize,
  GLdouble thickness, GLuint side, GLuint edge, GLuint whole)
{
  static GLUtriangulatorObj *tobj = NULL;
  GLdouble vertex[3], dx, dy, len;
  int i;
  int count = (int) (dataSize / (2 * sizeof(GLfloat)));

  if (tobj == NULL) {
    tobj = gluNewTess();  /* create and initialize a GLU
                             polygon tesselation object */
    //gluTessCallback(tobj, GLU_BEGIN, glBegin);
    //gluTessCallback(tobj, GLU_VERTEX, glVertex2fv);  /* semi-tricky */
    //gluTessCallback(tobj, GLU_END, glEnd);
  }
  glNewList(side, GL_COMPILE_AND_EXECUTE);
  glShadeModel(GL_SMOOTH);  /* smooth minimizes seeing
                               tessellation */
  gluBeginPolygon(tobj);
  for (i = 0; i < count; i++) {
    vertex[0] = data[i][0];
    vertex[1] = data[i][1];
    vertex[2] = 0;
    gluTessVertex(tobj, vertex, data[i]);
  }
  gluEndPolygon(tobj);
  glEndList();
  glNewList(edge, GL_COMPILE_AND_EXECUTE);
  //glShadeModel(GL_FLAT);  /* flat shade keeps angular hands
  //                           from being "smoothed"
  glBegin(GL_QUAD_STRIP);
  for (i = 0; i <= count; i++) {
    // mod function handles closing the edge
    glVertex3f(data[i % count][0], data[i % count][1], 0.0);
    glVertex3f(data[i % count][0], data[i % count][1], thickness);
    // Calculate a unit normal by dividing by Euclidean
    //   distance. We * could be lazy and use
    //   glEnable(GL_NORMALIZE) so we could pass in * arbitrary
    //   normals for a very slight performance hit.
    dx = data[(i + 1) % count][1] - data[i % count][1];
    dy = data[i % count][0] - data[(i + 1) % count][0];
    len = sqrt(dx * dx + dy * dy);
    glNormal3f(dx / len, dy / len, 0.0);
  }
  glEnd();
  glEndList();
  glNewList(whole, GL_COMPILE_AND_EXECUTE);
  glFrontFace(GL_CW);
  glCallList(edge);
  glNormal3f(0.0, 0.0, -1.0);  // constant normal for side
  glCallList(side);
  glPushMatrix();
  glTranslatef(0.0, 0.0, thickness);
  glFrontFace(GL_CCW);
  glNormal3f(0.0, 0.0, 1.0);  // opposite normal for other side
  glCallList(side);
  glPopMatrix();
  glEndList();
}

int
makeDinosaur(void)
{
  GLfloat bodyWidth = 3.0;

  glPushMatrix();

  extrudeSolidFromPolygon(body, sizeof(body), bodyWidth,
    BODY_SIDE, BODY_EDGE, BODY_WHOLE);
  extrudeSolidFromPolygon(arm, sizeof(arm), bodyWidth / 4,
    ARM_SIDE, ARM_EDGE, ARM_WHOLE);
  extrudeSolidFromPolygon(leg, sizeof(leg), bodyWidth / 2,
    LEG_SIDE, LEG_EDGE, LEG_WHOLE);
  extrudeSolidFromPolygon(eye, sizeof(eye), bodyWidth + 0.2,
    EYE_SIDE, EYE_EDGE, EYE_WHOLE);
//  glPopMatrix();
        glTranslated(0.0, 0.0, ZoomFactor);
        glRotatef(RotY, 1.0, 0.0, 0.0);
        glRotatef(RotX, 0.0, 1.0, 0.0);
  glNewList(DINOSAUR, GL_COMPILE_AND_EXECUTE);
  glTranslatef(-8, -8, -bodyWidth / 2);
  glMaterialfv(GL_FRONT, GL_DIFFUSE, skinColor);
  glCallList(BODY_WHOLE);
  glPushMatrix();
  glTranslatef(0.0, 0.0, bodyWidth);
  glCallList(ARM_WHOLE);
  glCallList(LEG_WHOLE);
  glTranslatef(0.0, 0.0, -bodyWidth - bodyWidth / 4);
  glCallList(ARM_WHOLE);
  glTranslatef(0.0, 0.0, -bodyWidth / 4);
  glCallList(LEG_WHOLE);
  glTranslatef(0.0, 0.0, bodyWidth / 2 - 0.1);
  glMaterialfv(GL_FRONT, GL_DIFFUSE, eyeColor);
  glCallList(EYE_WHOLE);
  glPopMatrix();
  glPopMatrix();
  glEndList();
  return DINOSAUR;
}

void
drawLightLocation(void)
{
  glPushMatrix();
        glTranslated(0.0, 0.0, ZoomFactor);
        glRotatef(RotY, 1.0, 0.0, 0.0);
        glRotatef(RotX, 0.0, 1.0, 0.0);
  glDisable(GL_LIGHTING);
  glDisable(GL_TEXTURE_2D);
  glColor3f(1.0, 1.0, 0.0);
  if (directionalLight) {
    /* Draw an arrowhead. */
    glDisable(GL_CULL_FACE);
    glTranslatef(light0_position[0], light0_position[1], light0_position[2]);
    glRotatef(lightAngle * -180.0 / M_PI, 0, 1, 0);
    glRotatef(atan(lightHeight/12) * 180.0 / M_PI, 0, 0, 1);
    glBegin(GL_TRIANGLE_FAN);
      glVertex3f(0, 0, 0);
      glVertex3f(2, 1, 1);
      glVertex3f(2, -1, 1);
      glVertex3f(2, -1, -1);
      glVertex3f(2, 1, -1);
      glVertex3f(2, 1, 1);
    glEnd();
    /* Draw a white line from light direction. */
    glColor3f(1.0, 1.0, 1.0);
    glBegin(GL_LINES);
      glVertex3f(0, 0, 0);
      glVertex3f(5, 0, 0);
    glEnd();
    glEnable(GL_CULL_FACE);
  } else {
    /* Draw a yellow ball at the light source. */
    glTranslatef(light0_position[0], light0_position[1], light0_position[2]);
    glutSolidSphere(1.0, 5, 5);
  }
  glEnable(GL_TEXTURE_2D);
  glEnable(GL_LIGHTING);
  glPopMatrix();
}

/*
 *  Initializes the control points of the surface to a small hill.
 *  The control points range from -3 to +3 in x, y, and z
 */
void init_surface(void)
{
   int u, v;
   for (u = 0; u < 4; u++) {
      for (v = 0; v < 4; v++) {
         ctlpoints[u][v][0] = 2.0*((GLfloat)u - 1.5);
         ctlpoints[u][v][1] = 2.0*((GLfloat)v - 1.5);

         if ( (u == 1 || u == 2) && (v == 1 || v == 2))
            ctlpoints[u][v][2] = 3.0;
         else
            ctlpoints[u][v][2] = -3.0;
      }
   }
}

void CALLBACK nurbsError(GLenum errorCode)
{
   const GLubyte *estring;

   estring = gluErrorString(errorCode);
   fprintf (stderr, "Nurbs Error: %s\n", estring);
   exit (0);
}
			
/*  Initialize material property and depth buffer.
 */
void init(void)
{
   init_surface();

   theNurb = gluNewNurbsRenderer();
   gluNurbsProperty(theNurb, GLU_SAMPLING_TOLERANCE, 25.0);
   gluNurbsProperty(theNurb, GLU_DISPLAY_MODE, GLU_FILL);
}

void display(void)
{
   GLfloat knots[8] = {0.0, 0.0, 0.0, 0.0, 1.0, 1.0, 1.0, 1.0};
   GLfloat edgePt[5][2] = /* counter clockwise */
      {{0.0, 0.0}, {1.0, 0.0}, {1.0, 1.0}, {0.0, 1.0}, {0.0, 0.0}};
   GLfloat curvePt[4][2] = /* clockwise */ 
      {{0.25, 0.5}, {0.25, 0.75}, {0.75, 0.75}, {0.75, 0.5}};
   GLfloat curveKnots[8] = 
      {0.0, 0.0, 0.0, 0.0, 1.0, 1.0, 1.0, 1.0};
   GLfloat pwlPt[4][2] = /* clockwise */ 
      {{0.75, 0.5}, {0.5, 0.25}, {0.25, 0.5}};
    float   scalefac;

   /*
   glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
     */
   glPushMatrix();
   glRotatef(330.0, 1.,0.,0.);
   scalefac = 10.03;
   glScaled(scalefac, scalefac, scalefac);
   glTranslated(5.0, 0.0, 10.0);

   gluBeginSurface(theNurb);
   gluNurbsSurface(theNurb, 8, knots, 8, knots,
                   4 * 3, 3, &ctlpoints[0][0][0],
                   4, 4, GL_MAP2_VERTEX_3);

   gluBeginTrim (theNurb);
      gluPwlCurve (theNurb, 5, &edgePt[0][0], 2, GLU_MAP1_TRIM_2);
   gluEndTrim (theNurb);

   gluBeginTrim (theNurb);
      gluNurbsCurve (theNurb, 8, curveKnots, 2,
                     &curvePt[0][0], 4, GLU_MAP1_TRIM_2);
      gluPwlCurve (theNurb, 3, &pwlPt[0][0], 2, GLU_MAP1_TRIM_2);
   gluEndTrim (theNurb);

   gluEndSurface(theNurb);
   glPopMatrix();
   //glFlush();
}









// Go into feedback mode and draw a rectangle around the object
#define FEED_BUFF_SIZE	4096

void MakeSelection(int nChoice)
	{
	// Space for the feedback buffer
	GLfloat feedBackBuff[FEED_BUFF_SIZE];

	// Storeage for counters, etc.
	int size,i,j,count;

	// Initial minimum and maximum values
	bRect.right = bRect.bottom = -999999.0f;
	bRect.left = bRect.top =  999999.0f;

	// Set the feedback buffer
	glFeedbackBuffer(FEED_BUFF_SIZE,GL_2D, feedBackBuff);

	// Enter feedback mode
	glRenderMode(GL_FEEDBACK);

	// Redraw the scene
    frm_pick->OpenGLAPPanel1->Repaint();
    //frm_pick->CreateObjects (GL_RENDER);


	// Leave feedback mode
	size = glRenderMode(GL_RENDER);

	// Parse the feedback buffer and get the
	// min and max X and Y window coordinates
	i = 0;
	while(i < size)
		{
		// Search for appropriate token
		if(feedBackBuff[i] == GL_PASS_THROUGH_TOKEN)
			if(feedBackBuff[i+1] == (GLfloat)nChoice)
			{
			i+= 2;
			// Loop until next token is reached
			while(i < size && feedBackBuff[i] != GL_PASS_THROUGH_TOKEN)
				{
				// Just get the polygons
				if(feedBackBuff[i] == GL_POLYGON_TOKEN)
					{
					// Get all the values for this polygon
					count = (int)feedBackBuff[++i]; // How many vertices
					i++;

					for(j = 0; j < count; j++)	// Loop for each vertex
						{
						// Min and Max X
						if(feedBackBuff[i] > bRect.right)
							bRect.right = feedBackBuff[i];

						if(feedBackBuff[i] < bRect.left)
							bRect.left = feedBackBuff[i];
						i++;

						// Min and Max Y
						if(feedBackBuff[i] > bRect.bottom)
							bRect.bottom = feedBackBuff[i];

						if(feedBackBuff[i] < bRect.top)
							bRect.top = feedBackBuff[i];
						i++;
						}
					}
				else
					i++;	// Get next index and keep looking
				}
			break;
			}
		i++;
		}
	}



// Process the selection, which is triggered by a right mouse
// click at (xPos, yPos).
#define BUFFER_LENGTH 64

void ProcessSelection(int xPos, int yPos)
	{
	// Space for selection buffer
	GLuint selectBuff[BUFFER_LENGTH];

	// Hit counter and viewport storeage
	GLint hits, viewport[4];

	// Setup selection buffer
	glSelectBuffer(BUFFER_LENGTH, selectBuff);
	
	// Get the viewport
	glGetIntegerv(GL_VIEWPORT, viewport);

	// Switch to projection and save the matrix
	glMatrixMode(GL_PROJECTION);
	glPushMatrix();

	// Change render mode
	glRenderMode(GL_SELECT);

	// Establish new clipping volume to be unit cube around
	// mouse cursor point (xPos, yPos) and extending two pixels
	// in the vertical and horzontal direction
	glLoadIdentity();
	gluPickMatrix(xPos, viewport[3] - yPos, 20,20, viewport);

	// Apply perspective matrix
	gluPerspective(60.0f, fAspect, 1.0, 425.0);

	// Draw the scene
    // frm_pick->CreateObjects (GL_RENDER);
    frm_pick->OpenGLAPPanel1->Repaint();
	// DrawObjects();

	// Collect the hits
	hits = glRenderMode(GL_RENDER);

	// Restore the projection matrix
	glMatrixMode(GL_PROJECTION);
	glPopMatrix();

	// Go back to modelview for normal rendering
	glMatrixMode(GL_MODELVIEW);

	// If a single hit occured, display the info.
	if(hits == 1)
		{
		MakeSelection(selectBuff[3]);
		if(nWho == selectBuff[3])
			nWho = 0;
		else
			nWho = selectBuff[3];
		}

	// glutPostRedisplay();
	}



//---------------------------------------------------------------------------
//  InitPlasma ()   - Initialize the plasma table and backbuffer
//---------------------------------------------------------------------------
void __fastcall Tfrm_pick::InitPlasma(void)
{
int x;
//bool    chk;

    for (x=0; x<256; x++) {
//        chk = false;
        // if (CheckListBoxFormula->State[0] == cbChecked) {
            PlasmaTable[x] = 0xFFF * (1. + cos(x * 2. * 3.1415 / 255));
//            chk = true;
//            }
/*
        if (CheckListBoxFormula->State[1] == cbChecked) {
            PlasmaTable[x] = (chk ? PlasmaTable[x] : 0) + exp((x+1)* 3.1415 / 256.);
            chk = true;
            }
        if (CheckListBoxFormula->State[2] == cbChecked) {
            PlasmaTable[x] = (chk ? PlasmaTable[x] : 0) + pow (x * 3. * 3.1415 / 256., (x+1.)* 3.1415 / 256.);
            chk = true;
            }
        if (CheckListBoxFormula->State[3] == cbChecked) {
            PlasmaTable[x] = (chk ? PlasmaTable[x] : 0) + pow (exp((x)* 3.1415 / 256.), cos(x * 3. * 3.1415 / 256.)+1.);
            chk = true;
            }
            */
        }
}
//---------------------------------------------------------------------------
//  DrawPlasma ()   -   Animates and draws the plama image, on the Image1
//---------------------------------------------------------------------------
void __fastcall Tfrm_pick::DrawPlasma(void)
{
//These variables holds the plasma direction and aspect.
static Byte PlasmaDir1,
            PlasmaDir2,
            PlasmaDir3,
            PlasmaDir4;

//These variables holds the old values of the plasma position.
static Byte PlasmaPos1 = 0,
            PlasmaPos2 = 0,
            PlasmaPos3 = 0,
            PlasmaPos4 = 0;

    long    TPos = 1;

static unsigned int  PlasmaColor,   // Final plasma color
                     *p_LinePtr;    // Pointer to a buffer's row of pixels
        long    PColor;

        int xx, yy;
        int  Onedarray;
static  bool    firstcol = true;
        long    FColor;

    if (!BMPTex) return;

    PlasmaDir1 = PlasmaPos1;
    PlasmaDir2 = PlasmaPos2;

    // We scan the entire bitmap, row by row
    for (yy = 0; yy < BMPTex->Height; yy++) {
        // We now obtain a pointer to the start of the current row

        PlasmaDir3 = PlasmaPos3;
        PlasmaDir4 = PlasmaPos4;

        // The pointer is accessed by the width of our buffer
        for(xx = 0; xx < BMPTex->Width; xx++) {

            Onedarray=yy*BMPTex->Width*BMPTex->Components+xx*BMPTex->Components;


            // Using the Plasma Table, we obtain the color for the given
            // pixel of the row. Try to change this line of code.
            PlasmaColor = PlasmaTable[PlasmaDir1] + PlasmaTable[PlasmaDir2] +
                          PlasmaTable[PlasmaDir3] + PlasmaTable[PlasmaDir4];



            // Check for the color chosen in the radio group.
            switch (6) {//RadioGroupPlasma->ItemIndex) {
                case 0:
                    // Only the red component. (green = blue = 0)
                   BMPTex->Pixels[Onedarray+0] =
                             GetRValue(PlasmaColor);
                   BMPTex->Pixels[Onedarray+1] =
                             GetGValue(0);
                   BMPTex->Pixels[Onedarray+2] =
                             GetBValue(0);
                    // p_LinePtr[xx] = (PlasmaColor << 16);
                    break;
                case 1:
                    // Only the green component. (red = blue = 0)
                    p_LinePtr[xx] = (PlasmaColor << 8);
                    break;
                case 2:
                    // Only the blue component. (red = green = 0)
                    p_LinePtr[xx] = (PlasmaColor);
                    break;
                case 3:
                    // This is a mix of colours. Try to changes the values,
                    // and remember that each color component is big as 1
                    // Byte.
                    /*
                    p_LinePtr[xx] = (((255 - PlasmaColor) << 16) |  //Red
                                     (PlasmaColor << 8) |           //Green
                                     (128 + (PlasmaColor >> 1)));   //Blue
                                     */
                   BMPTex->Pixels[Onedarray+0] =  PlasmaColor;
                   BMPTex->Pixels[Onedarray+1] =  PlasmaColor;
                   BMPTex->Pixels[Onedarray+2] =  PlasmaColor;
                    break;
                case 4:
                    // ---- Create a noise image
                    // Only the red component. (green = blue = 0)
                   BMPTex->Pixels[Onedarray+0] =
                             GetRValue(random (0xFFFFFF));
                   BMPTex->Pixels[Onedarray+1] =
                             GetGValue(random (0xFFFFFF));
                   BMPTex->Pixels[Onedarray+2] =
                             GetBValue(random (0xFFFFFF));
                    // p_LinePtr[xx] = random (0xFFFFFF);
                    break;
                case 5:
                    // ---- Cycle pixel color
                    // p_LinePtr[xx] += TrackBarSpeed->Position;
                    PColor = RGB (BMPTex->Pixels[Onedarray+0], BMPTex->Pixels[Onedarray+1], BMPTex->Pixels[Onedarray+2]);
                    PColor = PColor + 1 % 0xFFFFFF;
                   BMPTex->Pixels[Onedarray+0] =
                             GetRValue(PColor);
                   BMPTex->Pixels[Onedarray+1] =
                             GetGValue(PColor);
                   BMPTex->Pixels[Onedarray+2] =
                             GetBValue(PColor);
                    break;
                case 6:
                   FColor = RGB (BMPTex->Pixels[Onedarray+0], BMPTex->Pixels[Onedarray+1], BMPTex->Pixels[Onedarray+2]);
                   if (!firstcol) {
                       BMPTex->Pixels[Onedarray+0] =
                                 GetRValue(PColor);
                       BMPTex->Pixels[Onedarray+1] =
                                 GetGValue(PColor);
                       BMPTex->Pixels[Onedarray+2] =
                                 GetBValue(PColor);
                       }
                   firstcol = false;
                   PColor = FColor;
                   break;
                }

            PlasmaDir3 += (Byte) 1;
            PlasmaDir4 += (Byte) 2;
            }

        PlasmaDir1 += (Byte) 2;
        PlasmaDir2 += (Byte) 1;
        }

    // This section controls the plasma speed. Try to change these
    // values as you like.
    PlasmaPos1 += (Byte) 1*TPos;
    PlasmaPos2 -= (Byte) 3*TPos;
    PlasmaPos3 += (Byte) 5*TPos;
    PlasmaPos4 -= (Byte) 7*TPos;

    // Finally, the back buffer is copied into the Canvas's Form
    // Image1->Canvas->Draw (0, 0, backbuffer);
}
//---------------------------------------------------------------------------
//  Calculates new viewing point, and calling display list.
//  Increases FPS, when using display list.
//  ...later include this as automatic redraw in OpenGLAP package
//---------------------------------------------------------------------------
void __fastcall Tfrm_pick::OpenGLAPPanel1Paint(TObject *Sender)
{

	// Initialize the names stack
	glInitNames();
	glPushName(0);
	glPushName(1);
    glPushName(2);
	glPushName(3);


    OpenGLAPPanel1Resize(Sender);
    if (glIsList(DISPLAY) == GL_TRUE) {
        glDeleteLists(DISPLAY, 1);
       }
    if (glIsList(BODY_SIDE) == GL_TRUE) {
        glDeleteLists(BODY_SIDE, 1);
       }
    if (glIsList(BODY_EDGE) == GL_TRUE) {
        glDeleteLists(BODY_EDGE, 1);
       }
    if (glIsList(BODY_WHOLE) == GL_TRUE) {
        glDeleteLists(BODY_WHOLE, 1);
       }
    if (glIsList(ARM_SIDE) == GL_TRUE) {
        glDeleteLists(ARM_SIDE, 1);
       }

    //glNewList(DISPLAY, GL_COMPILE_AND_EXECUTE);
	//glMatrixMode(GL_MODELVIEW);
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);


    CreateObjects (GL_RENDER);
    /*
    Ortho = !Ortho;
    OpenGLAPPanel1Resize(Sender);
    CreateObjects (GL_RENDER);
    */
    //glEndList ();

	// If something is selected, draw a bounding box around it
	if(nWho != 0)
		{
		int viewport[4];

		// Get the viewport
		glGetIntegerv(GL_VIEWPORT, viewport);

		// Remap the viewing volume to match window coordinates (approximately)
		glMatrixMode(GL_PROJECTION);
		glPushMatrix();
		glLoadIdentity();
		
		// Establish clipping volume (left, right, bottom, top, near, far)
		glOrtho(viewport[0], viewport[2], viewport[3], viewport[1], -1, 1);
		glMatrixMode(GL_MODELVIEW);

		glDisable(GL_LIGHTING);
		glColor3ub(255,0,0);		
		glBegin(GL_LINE_LOOP);
			glVertex2i(bRect.left, bRect.top);
			glVertex2i(bRect.left, bRect.bottom);
			glVertex2i(bRect.right, bRect.bottom);
			glVertex2i(bRect.right, bRect.top);
		glEnd();
		glEnable(GL_LIGHTING);
		}

    Canvas->Font->Color = clWhite;
    Canvas->TextOut (1,1, "Hej dette er en test");
}
//---------------------------------------------------------------------------
BOOL  hitTest(int x, int y)
{
	GLuint selBuf[512];
	GLint hits;
	GLint viewport[4];
	GLdouble fovy = 50.0;
    GLdouble aspect = 1.0;
    GLdouble znear = 10.0, zfar=500.0;
	int i;

    if (active) return (FALSE);
    frm_pick->Timer1->Enabled = false;
    active = true;
    frm_pick->OpenGLAPPanel1->MakeOpenGLPanelCurrent();
	glGetIntegerv(GL_VIEWPORT,viewport);
	glSelectBuffer(512,selBuf);
	glRenderMode(GL_SELECT);

	glInitNames();
	glPushName(0);

	glMatrixMode(GL_PROJECTION);
    glLoadIdentity();

	gluPickMatrix((GLdouble)x,(GLdouble)(viewport[3]-y),30.0,30.0,viewport);

    /*
    gluPerspective(45, (GLdouble)frm_pick->OpenGLAPPanel1->Width/
                       (GLdouble)frm_pick->OpenGLAPPanel1->Height,zNear, zFar);
                       */
	// gluPerspective(fovy, aspect, znear, zfar);

    glMatrixMode(GL_MODELVIEW);

    active = false;
    frm_pick->CreateObjects (GL_SELECT);
    active = true;

	hits = glRenderMode(GL_RENDER);

	// process hits
	if(hits > 0) {
		// for each hit, first element in selBuf is 1,
		// since the hit objects are not hierarchial (they are POINTS)
		//
		for(i=0;i<hits;i++) {
			if(selBuf[4*i+3] == DISPLAY) {
                selected = selBuf[4*i+3];
                }
            /*
			if(selBuf[4*i+3] == AXES)
			{
				selected = selBuf[4*i+3];
                break;
			}
			else
				selected = -1;*/
		}
	}
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();


    /*
        gluPerspective(45, (GLdouble)frm_pick->OpenGLAPPanel1->Width/
                           (GLdouble)frm_pick->OpenGLAPPanel1->Height,zNear, zFar);
                           */

    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
	if(hits > 0) {
        active = false;
        frm_pick->OpenGLAPPanel1->Repaint ();
        active = true;
        }
	// setTransform();

    active = false;
    frm_pick->Timer1->Enabled = true;
	return hits > 0 ? TRUE : FALSE;
}
//---------------------------------------------------------------------------
// Resize handling of viewport
//---------------------------------------------------------------------------
void __fastcall Tfrm_pick::OpenGLAPPanel1Resize(TObject *Sender)
{

    nRange = -ZoomFactor;
    OpenGLAPPanel1->MakeOpenGLPanelCurrent();
   	glViewport(0,0,(GLsizei)OpenGLAPPanel1->Width,(GLsizei)OpenGLAPPanel1->Height);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();

    w = (GLdouble)OpenGLAPPanel1->Width;
    h = (GLdouble)OpenGLAPPanel1->Height;
	// Calculate aspect ratio of the window
	fAspect = (GLfloat)w/(GLfloat)h;
	// Establish clipping volume (left, right, bottom, top, near, far)
    if (Ortho) {
        if (w <= h)
            glOrtho (-nRange, nRange, -nRange*h/w, nRange*h/w, zNear, zFar);
        else
            glOrtho (-nRange*w/h, nRange*w/h, -nRange, nRange, zNear, zFar);
        }
    else {
	    //gluPerspective(60.0f, fAspect, 1.0, 425.0);
        if (Height==0)
            gluPerspective(45, (GLdouble)OpenGLAPPanel1->Width, zNear, zFar);
        else
            gluPerspective(45, (GLdouble)OpenGLAPPanel1->Width/
                               (GLdouble)OpenGLAPPanel1->Height,zNear, zFar);
        }
	glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
}
//---------------------------------------------------------------------------
// Mouse handling when user push a mousebutton
//---------------------------------------------------------------------------
void __fastcall Tfrm_pick::OpenGLAPPanel1MouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
    MouseButton = Button;
    MouseStatus = MB_DOWN;
    // Init Mouse Position On Button Click
    MPosX = X;
    MPosY = Y;

    ProcessSelection (X, Y);

}
//---------------------------------------------------------------------------
// Mouse handling when user releases mouse button
//---------------------------------------------------------------------------
void __fastcall Tfrm_pick::OpenGLAPPanel1MouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
    MouseButton = Button;
    MouseStatus = MB_UP;
}
//---------------------------------------------------------------------------
// Rotate and Zoom calculations for mouse movement
//---------------------------------------------------------------------------
void __fastcall Tfrm_pick::OpenGLAPPanel1MouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
    if (MouseButton == mbLeft &&
        MouseStatus ==  MB_DOWN) {
        if (X > MPosX ) RotX += X-MPosX;
        if (X < MPosX ) RotX -= MPosX-X;
        if (Y > MPosY ) RotY += Y-MPosY;
        if (Y < MPosY ) RotY -= MPosY-Y;
        MPosX = X;
        MPosY = Y;
        OpenGLAPPanel1->Repaint ();
        }
    if (MouseButton == mbRight &&
        MouseStatus ==  MB_DOWN) {
        if (X > MPosX ) ZoomFactor += (GLdouble)(X-MPosX) / (GLdouble) 4.0;
        if (X < MPosX ) ZoomFactor -= (GLdouble)(MPosX-X) / (GLdouble) 4.0;
        if (X > MPosY ) ZoomFactor += (GLdouble)(Y-MPosY) / (GLdouble) 4.0;
        if (X < MPosY ) ZoomFactor -= (GLdouble)(MPosY-Y) / (GLdouble) 4.0;
        MPosX = X;
        MPosY = Y;
        OpenGLAPPanel1->Repaint ();
        }
    if (!first_run) {
        //Close ();
        //Caption = "Moving mouse";
        }
    /*
    if (hitTest(X, Y)) {
        Caption = "Hit";
        }
    else {
        Caption = "No Hit";
        }
        */
}
//---------------------------------------------------------------------------
// Init viewport and perspective setup.
//---------------------------------------------------------------------------
void __fastcall Tfrm_pick::OpenGLAPPanel1Init(TObject *Sender)
{

    ListBox1->Clear ();
    ListBox1->Items->Add ("Vendor: " + String((char*)glGetString (GL_VENDOR)));
    ListBox1->Items->Add ("Renderer: " + String((char*)glGetString (GL_RENDERER)));
    ListBox1->Items->Add ("Version: " + String((char*)glGetString (GL_VERSION)));
    ListBox1->Items->Add ("Extensions: " + String((char*)glGetString (GL_EXTENSIONS)));

    OpenGLAPPanel1->MakeOpenGLPanelCurrent();
   	glViewport(0,0,(GLsizei)OpenGLAPPanel1->Width,(GLsizei)OpenGLAPPanel1->Height);
	glMatrixMode(GL_PROJECTION);

	glLoadIdentity();


    glPushMatrix();
    //...generates a single display list, if more added increase range
    // DISPLAY = glGenLists(1);
    /*
    if (Height==0)
     	gluPerspective(45, (GLdouble)OpenGLAPPanel1->Width,  zNear, zFar);
    else
        gluPerspective(45, (GLdouble)OpenGLAPPanel1->Width/
                           (GLdouble)OpenGLAPPanel1->Height, zNear, zFar);
                           */
    glPopMatrix();
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	glEnable(GL_DEPTH_TEST);
    glEnable(GL_AUTO_NORMAL);
    glDisable(GL_POLYGON_SMOOTH);
    Smooth = false;
    //glClearColor(0.0,0.0,0.0,1.0);
    glClearColor(0.5f,0.5f,0.5f,1.0f);			// We'll Clear To The Color Of The Fog ( Modified )


    init();
 }


//---------------------------------------------------------------------------
// Creates all visible objects, currently using one display list
//---------------------------------------------------------------------------
void __fastcall Tfrm_pick::CreateObjects (GLenum mode)
{


    char    str[255];
static    double XYZ[3];
  static GLint  s_vec[]={1,0,0,0};
  static GLint  t_vec[]={1,1,1,0};
  static bool zz = true;
static  float col[3] = {0.01, 0.01, 0.01};
static float timecolor = 0x0000FF;
static  long timeval=1;
static  long sw = 0, i;
    float   scalefac;
float           dtime = 0;



  String  TimeStr;

    if (active) return;
    active = true;

    DrawPlasma();
    OpenGLAPPanel1->MakeOpenGLPanelCurrent();

    /*
    sw++;
    if (sw % 100 == 0) {
        if (OpenGLAPPanel1->Font3D_Format == WGL_FONT_POLYGONS) {
            OpenGLAPPanel1->Font3D_Format = WGL_FONT_LINES;
            }
        else {
            OpenGLAPPanel1->Font3D_Format = WGL_FONT_POLYGONS;
            }
        OpenGLAPPanel1->Create3DFont ();
        sw = 0;
        }
        */
        /*
    if (first_run) {
        BMPTex = OpenGLAPPanel1->LoadBMPTexture(".\\texture\\alarm.bmp",false);
        }
        */

glFogi(GL_FOG_MODE, fogMode[fogfilter]);		// Fog Mode
glFogfv(GL_FOG_COLOR, fogColor);			// Set Fog Color
glFogf(GL_FOG_DENSITY, 0.35f);				// How Dense Will The Fog Be
glHint(GL_FOG_HINT, GL_DONT_CARE);			// Fog Hint Value
glFogf(GL_FOG_START, 1.0f);				// Fog Start Depth
glFogf(GL_FOG_END, 5.0f);				// Fog End Depth
glEnable(GL_FOG);					// Enables GL_FOG



    glEnable(GL_LIGHTING);
    glPushMatrix();

    // ---- Used for setting up light and materials
    glLightfv(GL_LIGHT0, GL_POSITION, light0_position);
    glLightfv(GL_LIGHT0, GL_AMBIENT, light0_ambient);
    glLightModelfv(GL_LIGHT_MODEL_LOCAL_VIEWER, light0_ambient);
    glEnable(GL_LIGHTING);
    glEnable(GL_LIGHT0);
    glEnable(GL_NORMALIZE);
    glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, mat_ambuse);
    glMaterialfv(GL_FRONT, GL_FRONT, mat_ambuse);
    glMaterialfv(GL_FRONT, GL_SPECULAR, mat_specular);
    glMaterialf (GL_FRONT, GL_SHININESS, mat_shininess);

        glTranslated(0.0, 0.0, ZoomFactor);
        glRotatef(RotY, 1.0, 0.0, 0.0);
        glRotatef(RotX, 0.0, 1.0, 0.0);


    if (BMPTex && mode == GL_RENDER) {
      BMPTex->SetAlpha(128);
      glPixelStorei(GL_UNPACK_ALIGNMENT, 2);
      glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
      glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
      glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
      glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
      glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_DECAL);
      glTexImage2D(GL_TEXTURE_2D, 0, BMPTex->GetComponents(),
                   BMPTex->GetWidth(), BMPTex->GetHeight(),0,
                   BMPTex->GetFormat(),BMPTex->GetType(),
                   BMPTex->GetPixels());
      glEnable(GL_TEXTURE_2D);
      glTexGeni(GL_S,GL_TEXTURE_GEN_MODE,GL_OBJECT_LINEAR);
      glTexGeniv(GL_S,GL_OBJECT_PLANE,s_vec);
      glTexGeni(GL_T,GL_TEXTURE_GEN_MODE,GL_OBJECT_LINEAR);
      glTexGeniv(GL_T,GL_OBJECT_PLANE,t_vec);
      glEnable(GL_TEXTURE_GEN_S);
      glEnable(GL_TEXTURE_GEN_T);
      }


    //...create text defined by user
    //glColor3f(1.0,0.4,0.2);
    col[0] = (float)GetRValue(0x0000FF) / 255.0F;
    col[1] = (float)GetGValue(timecolor);
    col[2] = (float)GetBValue((long)timecolor);
    glColor3f (col[0],col[1],col[2]);

    timecolor = (clock()-start) / CLK_TCK;
    TimeStr = TimeToStr(Time());
    if (first_run) {
        OpenGLAPPanel1->Get3DTextSize (TimeStr, XYZ);
        }
    //glTranslated(-XYZ[0]/2.0,-XYZ[1]/2.0 + 1.3,-XYZ[2]/2.0);
    glTranslated(-XYZ[0]/2.0,0.0,-XYZ[2]/2.0);
    glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, mat_ambuse);
    if (mode == GL_RENDER) {
        OpenGLAPPanel1->Draw3DText(TimeStr);
        }

    if (mode == GL_RENDER) {
        glDisable(GL_TEXTURE_GEN_S);
        glDisable(GL_TEXTURE_GEN_T);
        glDisable(GL_TEXTURE_2D);
        }
	glLoadName(SELNAME++);
	glPassThrough((GLfloat)SELNAME++);

    glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, mat_ambuse2);
    glTranslatef(-XYZ[0]/2.0,0.0,-XYZ[2]/2.0);
    glTranslated(0.0, -1.0, -2.0);
    glRotatef(45., 0.0, -1.0, 0.0);

    scalefac = 0.03;
    glScaled(scalefac, scalefac, scalefac);
    glBegin(GL_LINES);
        glColor3f(1.0,0.0,0.0);
        glVertex3f(0.0,0.0,0.0);
        glVertex3f(100.0,0.0,0.0);

        glColor3f(0.0,1.0,0.0);
        glVertex3f(0.0,0.0,0.0);
        glVertex3f(0.0,100.0,0.0);

        glColor3f(0.0,0.0,1.0);
        glVertex3f(0.0,0.0,0.0);
        glVertex3f(0.0,0.0,100.0);
    glEnd();


    //scalefac /= 10.0;
    //glScaled(scalefac, scalefac, scalefac);
    if(mode == GL_SELECT)
        glLoadName(AXES);

    // glColor3f(0.5,0.5,0.5);
	for(i=1;i<=10;i++) 	{
            if (mode == GL_SELECT) {
				glLoadName(i);
                }
        if(i == selected) {
            mat_ambuse2[0] = 1.0;
            mat_ambuse2[1] = 1.0;
            mat_ambuse2[2] = 0;
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, mat_ambuse2);
            glColor3f(1.0,1.0,0.0);
            }
        else {
            mat_ambuse2[0] = 0.5;
            mat_ambuse2[1] = 0.5;
            mat_ambuse2[2] = 0.5;
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, mat_ambuse2);
            glColor3f(0.5,0.5,0.5);
            }
		glBegin(GL_LINES);
            glNormal3f( 0.0F, 0.0F, 1.0F);
			glVertex3f(i*10.0,  0.0,0.0);
			glVertex3f(i*10.0,100.0,0.0);

			glVertex3f(  0.0,i*10.0,0.0);
			glVertex3f(100.0,i*10.0,0.0);


			glVertex3f(  0.0, 0.0, i*10.0);
			glVertex3f(100.0, 0.0, i*10.0);

			glVertex3f(i*10.0,  0.0,   0.0);
			glVertex3f(i*10.0,  0.0, 100.0);


			glVertex3f(  0.0, 0.0,   i*10.0);
			glVertex3f(  0.0, 100.0, i*10.0);

			glVertex3f(  0.0,i*10.0, 0.0);
			glVertex3f(0.0,i*10.0, 100.0);
		glEnd();
	    }


    /* draw six faces of a cube */
    glPushMatrix();
//    glFrustum(-0.5F, 0.5F, -0.5F, 0.5F, 1.0F, 3.0F);
    scalefac = 10.03;
    glScaled(scalefac, scalefac, scalefac);
    // glTranslated(-XYZ[0]/2.0,0.0,-XYZ[2]/2.0);


	glLoadName(SELNAME++);
	glPassThrough((GLfloat)SELNAME++);
    glBegin(GL_QUADS);
    glNormal3f( 0.0F, 0.0F, 10.0F);
    glVertex3f( 0.5F, 0.5F, 0.5F); glVertex3f(-0.5F, 0.5F, 0.5F);
    glVertex3f(-0.5F,-0.5F, 0.5F); glVertex3f( 0.5F,-0.5F, 0.5F);

    /*
    glNormal3f( 0.0F, 0.0F,-1.0F);
    glVertex3f(-0.5F,-0.5F,-0.5F); glVertex3f(-0.5F, 0.5F,-0.5F);
    glVertex3f( 0.5F, 0.5F,-0.5F); glVertex3f( 0.5F,-0.5F,-0.5F);

    glNormal3f( 0.0F, 1.0F, 0.0F);
    glVertex3f( 0.5F, 0.5F, 0.5F); glVertex3f( 0.5F, 0.5F,-0.5F);
    glVertex3f(-0.5F, 0.5F,-0.5F); glVertex3f(-0.5F, 0.5F, 0.5F);

    glNormal3f( 0.0F,-1.0F, 0.0F);
    glVertex3f(-0.5F,-0.5F,-0.5F); glVertex3f( 0.5F,-0.5F,-0.5F);
    glVertex3f( 0.5F,-0.5F, 0.5F); glVertex3f(-0.5F,-0.5F, 0.5F);

    glNormal3f( 1.0F, 0.0F, 0.0F);
    glVertex3f( 0.5F, 0.5F, 0.5F); glVertex3f( 0.5F,-0.5F, 0.5F);
    glVertex3f( 0.5F,-0.5F,-0.5F); glVertex3f( 0.5F, 0.5F,-0.5F);
    glNormal3f(-1.0F, 0.0F, 0.0F);
    glVertex3f(-0.5F,-0.5F,-0.5F); glVertex3f(-0.5F,-0.5F, 0.5F);
    glVertex3f(-0.5F, 0.5F, 0.5F); glVertex3f(-0.5F, 0.5F,-0.5F);
    */
    glEnd();
    glPopMatrix();

	// glLoadIdentity();
    // glFrustum(-0.5F, 0.5F, -0.5F, 0.5F, -1.0F, 1.0F);
    glTranslatef(light0_position[0], light0_position[1], light0_position[2]);
	glLoadName(SELNAME++);
	glPassThrough((GLfloat)SELNAME++);
    glutSolidCube (10.0);



    // ---- Create belzier formula
    scalefac = 10.03;
    glScaled(scalefac, scalefac, scalefac);
    

	Point3 *result = new Point3[num_points];
    evaluateBezierSegment_fd(control, num_points, result);
    // ---- Draw Control Points

	glLoadName(SELNAME++);
	glPassThrough((GLfloat)SELNAME++);
    glBegin(GL_LINE_STRIP);
    mat_ambuse2[0] = 0.0;
    mat_ambuse2[1] = 0.0;
    mat_ambuse2[2] = 1;
    glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, mat_ambuse2);
    glColor3f(1.0,0.0,1.0);
	for(i=0;i<4;i++) 	{
        glBegin(GL_LINES);
        glVertex3f(control[i].x, control[i].y, control[i].z);
        i++;
        glVertex3f(control[i].x, control[i].y, control[i].z);
        glEnd ();
        }


    mat_ambuse2[0] = 1.0;
    mat_ambuse2[1] = 1.0;
    mat_ambuse2[2] = 0;
    glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, mat_ambuse2);
    glColor3f(1.0,1.0,0.0);

    for (len =0; len >-10; len--) {
        glBegin(GL_LINE_STRIP);
        for(i=0;i<num_points;i++) 	{
            glVertex3f(result[i].x, result[i].y, result[i].z);
            }
        glEnd ();
        glBegin(GL_LINE_STRIP);
        for(i=0;i<num_points;i++) 	{
            glVertex3f(result[i].x+len, result[i].y, result[i].z);
            }
        glEnd ();
        glBegin(GL_LINES);
        for(i=0;i<num_points;i++) 	{
            glVertex3f(result[i].x, result[i].y, result[i].z);
            glVertex3f(result[i].x+len, result[i].y, result[i].z);
            }
        glEnd ();
        }
    delete result;




//    display ();
    glPopMatrix();

    // makeDinosaur();
    //drawLightLocation();

    if (mode == GL_RENDER && RotateWorld) {
        RotX = (long)(RotX+1) % 360;
        RotY = (long)(RotY) % 360;
        }
    // Caption = "";
    End = GetTickCount();
    QueryPerformanceCounter(&TimeEnd);
    QueryPerformanceFrequency(&TimeFreq);
    dtime = ((float) TimeEnd.QuadPart - (float) TimeBeg.QuadPart) / (float)TimeFreq.QuadPart;
    sprintf (str, "Rotation (%.0f,%.0f) .. FPS %.1f", RotX, RotY, 1.0F/dtime);
    Start = End;
    TimeBeg = TimeEnd;

    LabelInfo->Caption = str;
    active = false;

    /*
    light0_position[0] += ((float)random (100)/100.0) * random (100) >= 49 ? 1.:-1.;
    light0_position[1] += ((float)random (100)/100.0) * random (100) >= 49 ? 1.:-1.;
    light0_position[2] += ((float)random (100)/100.0) * random (100) >= 49 ? 1.:-1.;
    */
    //OpenGLAPPanel1->Repaint ();
}
//---------------------------------------------------------------------------
// Update objects by return key
//---------------------------------------------------------------------------          1
void __fastcall Tfrm_pick::Timer1Timer(TObject *Sender)
{
   //CreateObjects ();
   OpenGLAPPanel1->Repaint ();
   if (first_run) {
        Top = 0;
        Left = 0;
        first_run = false;
        Height = Screen->Height+1;
        Width  = Screen->Width+1;
        }
}
//---------------------------------------------------------------------------
void __fastcall Tfrm_pick::FormKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    switch (Key) {
        case 'G':
            fogfilter+=1;					// Increase fogfilter By One
            if (fogfilter>2) {				// Is fogfilter Greater Than 2?
                fogfilter=0;				// If So, Set fogfilter To Zero
                }
            glFogi (GL_FOG_MODE, fogMode[fogfilter]);	// Fog Mode
            break;
        case '1':
            num_points--;
            break;
        case '2':
            num_points++;
            break;
        case '3':
            control[1].x += 1.;
            break;
        case '4':
            control[1].x -= 1.;
            break;
        case '5':
            control[1].y += 1.;
            break;
        case '6':
            control[1].y -= 1.;
            break;
        case '7':
            control[1].z += 1.;
            break;
        case '8':
            control[1].z -= 1.;
            break;
        case 'O':
            Ortho = !Ortho;
            break;
        case 'S':
            Smooth = !Smooth;
            if (!Smooth)
                glDisable(GL_POLYGON_SMOOTH);
            if (Smooth)
                glEnable (GL_POLYGON_SMOOTH);
            break;
        case 'D':
            LightSource++;
            switch (LightSource) {
                case 0:
                    glLightModelfv(GL_LIGHT_MODEL_AMBIENT, light0_ambient);
                    break;
                case 1:
                    glLightModelfv(GL_LIGHT_MODEL_LOCAL_VIEWER, light0_ambient);
                    break;
                case 2:
                    glLightModelfv(GL_LIGHT_MODEL_TWO_SIDE, light0_ambient);
                    break;
                default:
                    LightSource = -1;
                    break;
                }

            break;
        case 'R':
            RotateWorld = !RotateWorld;
            break;
        case 'T':
            if (BMPTex) {
                delete BMPTex;
                BMPTex = NULL;
                }
            else {
                BMPTex = OpenGLAPPanel1->LoadBMPTexture(".\\sunset.bmp",false);
                }
            break;
        case 'F':
            if (OpenGLAPPanel1->Font3D_Format == WGL_FONT_POLYGONS) {
                OpenGLAPPanel1->Font3D_Format = WGL_FONT_LINES;
                }
            else {
                OpenGLAPPanel1->Font3D_Format = WGL_FONT_POLYGONS;
                }
            OpenGLAPPanel1->Create3DFont ();
            break;
        case VK_NEXT:
                light0_position [1] -= 1.0;
                glLightfv(GL_LIGHT0, GL_POSITION, light0_position);
            break;
        case VK_PRIOR:
                light0_position [1] += 1.0;
                glLightfv(GL_LIGHT0, GL_POSITION, light0_position);
            break;
        case VK_UP:
                light0_position [2] -= 1.0;
                glLightfv(GL_LIGHT0, GL_POSITION, light0_position);
            break;
        case VK_DOWN:
                light0_position [2] += 1.0;
                glLightfv(GL_LIGHT0, GL_POSITION, light0_position);
            break;
        case VK_LEFT:
                light0_position [0] -= 1.0;
                glLightfv(GL_LIGHT0, GL_POSITION, light0_position);

            break;
        case VK_RIGHT:
                light0_position [0] += 1.0;
                glLightfv(GL_LIGHT0, GL_POSITION, light0_position);

            break;
        case VK_ADD:    
            mat_shininess++;
            glMaterialf (GL_FRONT, GL_SHININESS, mat_shininess);
            Caption = "Shininess Level = " + FloatToStr(mat_shininess);
            break;
        case VK_SUBTRACT:
            mat_shininess--;
            glMaterialf (GL_FRONT, GL_SHININESS, mat_shininess);
            Caption = "Shininess Level = " + FloatToStr(mat_shininess);
            break;
        default:
            /*
            if (!first_run) {
                Close ();
                }
                */
            break;
        }
}
//---------------------------------------------------------------------------
void __fastcall Tfrm_pick::FormCreate(TObject *Sender)
{
    // Screen->Cursor = crNone;
    Start = GetTickCount ();
    InitPlasma();
}
//---------------------------------------------------------------------------

void __fastcall Tfrm_pick::FormClose(TObject *Sender, TCloseAction &Action)
{
    Screen->Cursor = crDefault;
    if (BMPTex) {
        delete BMPTex;
        }
    delete control;
}
//---------------------------------------------------------------------------






/*
 * This function evaluates a bezier curve using full forward
 * forward differencing.
 */
void evaluateBezierSegment_fd(Point3 *control,int num_points,   Point3 *result) {
    float q;
    Point3 P0;
    Point3 P1;
    Point3 P2;
    Point3 P3;
    Point3 a, b, c, d, S, U, V, W;


	// var q is the change in t between successive evaluations.
	q = 1.f/(num_points-1); // q is dependent on the number of GAPS = POINTS-1
	// recreate the names used in the derivation
	P0 = control[0];
	P1 = control[1];
	P2 = control[2];
	P3 = control[3];
	// coefficients of the cubic polynomial that we're FDing -
	a = P0;
	b.x = (P1.x-P0.x)*3;
	b.y = (P1.y-P0.y)*3;
	b.z = (P1.z-P0.z)*3;
//	Vector4 c = 3*(P2-2*P1+P0);
	c.x = 3*(P2.x-2*P1.x+P0.x);
	c.y = 3*(P2.y-2*P1.y+P0.y);
	c.z = 3*(P2.z-2*P1.z+P0.z);
//	Vector4 d = P3-3*P2+3*P1-P0;
	d.x = P3.x-3*P2.x+3*P1.x-P0.x;
	d.y = P3.y-3*P2.y+3*P1.y-P0.y;
	d.z = P3.z-3*P2.z+3*P1.z-P0.z;
	// initial values of the poly and the 3 diffs -
	S  = a;						// the poly value
	U.x  = b.x*q + c.x*q*q + d.x*q*q*q;	// 1st order diff (quadratic)
	U.y  = b.y*q + c.y*q*q + d.y*q*q*q;	// 1st order diff (quadratic)
	U.z  = b.z*q + c.z*q*q + d.z*q*q*q;	// 1st order diff (quadratic)

	V.x  = 2*c.x*q*q + 6*d.x*q*q*q;		// 2nd order diff (linear)
	V.y  = 2*c.y*q*q + 6*d.y*q*q*q;		// 2nd order diff (linear)
	V.z  = 2*c.z*q*q + 6*d.z*q*q*q;		// 2nd order diff (linear)

	W.x  = 6*d.x*q*q*q;				// 3rd order diff (constant)
	W.y  = 6*d.y*q*q*q;				// 3rd order diff (constant)
	W.z  = 6*d.z*q*q*q;				// 3rd order diff (constant)
	result[0] = P0;	// first point on the curve is always P0.
	for (int i=1;i<num_points;i++) {
		// calculate the next value and update the deltas
		S.x += U.x;			// update poly value
		S.y += U.y;			// update poly value
		S.z += U.z;			// update poly value
		U.x += V.x;			// update 1st order diff value
		U.y += V.y;			// update 1st order diff value
		U.z += V.z;			// update 1st order diff value
		V.x += W.x;			// update 2st order diff value
		V.y += W.y;			// update 2st order diff value
		V.z += W.z;			// update 2st order diff value
		// 3rd order diff is constant => no update needed.
		// new poly store in the output array
		result[i] = S;
	}
}








